-module(ePort).

-behavior(gen_server).



-compile([export_all]).

-define(PORT_NAME,   "./priv/tporti").

start_link() ->
    gen_server:start_link().


control(Port, Data) ->
    Port ! {self(), {command, Data}},
    receive
        {Port, {data, AnswerData}} ->
            io:format("IMY******************111 ~p", [AnswerData]),
            AnswerData;
        {Port, {exit_status, _Status}} ->
            io:format("IMY******************2222 ~p", [_Status]),
            erlang:error(port_exit)
    after 1000 ->
        io:format("IMY******************333 ~p", [no_receive]),
        no_receive
    end.

open() ->
    Opts = [{packet, 2}, binary, exit_status, use_stdio],
    erlang:open_port({spawn_executable, ?PORT_NAME}, Opts).


tt() ->
    case get(ppp) of
        undefined ->
            P = open(),
            put(ppp, P);
        _ ->
            ignore
    end,

    control(get(ppp), term_to_binary({$g, 12432, 4324})).

tt(CmdId) ->
    case get(ppp) of
        undefined ->
            P = open(),
            put(ppp, P);
        _ ->
            ignore
    end,
    case CmdId of
        $g ->
            control(get(ppp), term_to_binary({CmdId, 12432, 4324}));
        $u ->
            control(get(ppp), term_to_binary({CmdId, 12432, 4324}));
        $t ->
            ignore;
        _ ->
            control(get(ppp), term_to_binary({CmdId, 12432, 4324}))
    end.


